<template>
  <div class="app-container">
    <el-tabs v-model="activeName" type="border-card">
      <el-tab-pane label="方案管理" name="first">
        <index-scheme/>
      </el-tab-pane>
      <el-tab-pane label="基础数据" name="second">
        <el-card class="topCard">
          <div class="topDiv">
            <span style="margin-left: 10px">工位号：</span>
            <el-select v-model="stationNumberValue" placeholder="请选择工位号" clearable size="small" style="width: 200px" @change="searchTable">
              <el-option
                v-for="item in stationNumber"
                :key="item.value"
                :label="item.label"
                :value="item.value"
                size="mini"/>
            </el-select>
            <el-button type="primary" plain size="small" icon="el-icon-order" @click="searchTable()">查询</el-button>
            <el-button type="primary" icon="el-icon-circle-plus-outline" size="small" @click="addTo">新增</el-button>
          </div>
          <div>
            <el-col :span="12">
              <el-table
                ref="multipleTable"
                :data="tableData"
                :header-cell-style="{background:'#eef1f6',color:'#606266'}"
                :cell-class-name="tableRowClassName"
                height="680px"
                class="main"
                tooltip-effect="dark"
                style="width: 100%"
                border
                size="mini">
                <el-table-column label="工位号" align="center" width="100px">
                  <template slot-scope="scope">
                    {{ scope.row.工位号 }}
                  </template>
                </el-table-column>
                <el-table-column label="类别" align="center">
                  <template slot-scope="scope">
                    <div style="white-space: pre-line !important;">{{ scope.row.类别 }}</div>
                  </template>
                </el-table-column>
                <el-table-column label="测试方法" align="center" width="120px">
                  <template slot-scope="scope">
                    <div style="white-space: pre-line !important;">{{ scope.row.测试方法 }}</div>
                  </template>
                </el-table-column>
                <el-table-column label="检测要求" align="center" width="120px">
                  <template slot-scope="scope">
                    <div style="white-space: pre-line !important;">{{ scope.row.检测要求 }}</div>
                  </template>
                </el-table-column>
                <el-table-column label="实测值" align="center" width="120px">
                  <template slot-scope="scope">
                    <div style="white-space: pre-line !important;">{{ scope.row.实测值 }}</div>
                  </template>
                </el-table-column>
                <el-table-column align="center" label="操作" width="100">
                  <template slot-scope="scope">
                    <el-button type="text" @click="editInformation(scope.row)"><i class="el-icon-edit"/></el-button>
                    <el-button type="text" style="color: #ff0000" @click="deleteInformation(scope.row)"><i class="el-icon-delete"/></el-button>
                  </template>
                </el-table-column>
              </el-table>

            </el-col>
            <el-col :span="12">
              <el-table
                ref="multipleTable"
                :data="tableData1"
                :header-cell-style="{background:'#eef1f6',color:'#606266'}"
                :cell-class-name="tableRowClassName"
                class="main"
                tooltip-effect="dark"
                style="width: 70%;margin-left: 10px"
                border
                size="mini">
                <el-table-column label="数据名称" align="center" width="100px">
                  <template slot-scope="scope">
                    {{ scope.row.数据名称 }}
                  </template>
                </el-table-column>
                <el-table-column label="数据值" align="center">
                  <template slot-scope="scope">
                    <el-button v-if="scope.row.数据值 === 'button'" type="primary" icon="el-icon-check" size="small" @click="submitUpdate1">修改</el-button>
                    <el-input v-else v-model="scope.row.数据值" size="mini" />
                  </template>
                </el-table-column>
              </el-table>
            </el-col>
          </div>
        </el-card>
      </el-tab-pane>
    </el-tabs>
    <el-dialog :visible.sync="dialogFormVisible" :title="title" center style="min-height: 200px;" width="400px">
      <el-form ref="form" :model="form" :rules="rules" label-position="right" label-width="110px">
        <el-form-item label="工位号" prop="stationNumber" style="display: inline-block">
          <el-select v-if="title === '添加'" v-model="form.stationNumber" placeholder="请选择工位号" clearable size="small" style="width: 200px">
            <el-option
              v-for="item in stationNumber"
              :key="item.value"
              :label="item.label"
              :value="item.value"
              size="mini"/>
          </el-select>
          <el-input v-if="title === '编辑'" v-model="form.stationNumber" size="small" readonly style="width:200px;"/>
        </el-form-item>
        <el-form-item label="类别" prop="类别" style="display: inline-block">
          <el-input v-model="form.类别" size="small" clearable style="width:200px;"/>
        </el-form-item>
        <el-form-item label="测试方法" prop="测试方法" style="display: inline-block">
          <el-input v-model="form.测试方法" size="small" clearable style="width:200px;"/>
        </el-form-item>
        <el-form-item label="检测要求" prop="检测要求" style="display: inline-block">
          <el-input v-model="form.检测要求" size="small" clearable style="width:200px;"/>
        </el-form-item>
        <el-form-item label="实测值" prop="实测值" style="display: inline-block">
          <el-input v-model="form.实测值" size="small" clearable style="width:200px;"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="small" @click="callOff('form')">取消</el-button>
        <el-button v-if="title === '添加'" type="primary" size="small" @click="submitAdd('form')">确定</el-button>
        <el-button v-if="title === '编辑'" type="primary" size="small" @click="submitUpdate('form')">确定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import indexScheme from './indexScheme.vue'
export default {
  components: {
    indexScheme
  },
  data() {
    return {
      tableData: [], // 总数据数组
      tableData1: [], // 总数据数组
      stationNumber: [],
      activeName: 'first',
      stationNumberValue: '',
      stationName: '',
      moduleDescription: [],
      moduleDescriptionValue: '',
      engineTypeValue: '',
      engineTypeValue1: '',
      engineTypeName: '',
      engineType: [],
      tagIDArr: [
        {
          label: 'lbl_datagrid_quality_name',
          value: 'lbl_datagrid_quality_name'
        }, {
          label: 'lbl_datagrid_quality_item1',
          value: 'lbl_datagrid_quality_item1'
        }, {
          label: 'lbl_datagrid_quality_item2',
          value: 'lbl_datagrid_quality_item2'
        }
      ],
      isDisable: [
        {
          label: '是',
          value: 1
        }, {
          label: '否',
          value: 0
        }
      ],
      isDisableValue: 0,
      labelText: '',
      labelNumber: '',
      dialogFormVisible: false,
      dialogFormVisible1: false,
      dialogFormVisible4: false,
      title: '',
      form: {
        stationNumber: '',
        ID: 0,
        类别: '',
        测试方法: '',
        检测要求: '',
        实测值: ''
      },
      rules: {
        stationNumber: [{ required: true, message: '请选择工位号', trigger: 'change' }],
        类别: [{ required: true, message: '请输入类别', trigger: 'blur' }],
        测试方法: [{ required: true, message: '请输入测试方法', trigger: 'blur' }],
        检测要求: [{ required: true, message: '请输入检测要求', trigger: 'blur' }],
        实测值: [{ required: true, message: '请输入实测值', trigger: 'blur' }]
      },
      form1: {
        number: '',
        text: '',
        work: '',
        fun: ''
      },
      rules1: {
        number: [{ required: true, message: '请输入序号', trigger: 'blur' }],
        text: [{ required: true, message: '请输入操作内容', trigger: 'blur' }]
      },
      form4: {
        engineTypeValue: '',
        stationNumberValue: ''
      },
      rules4: { // 订单下发验证
        engineTypeValue: [{ required: true, message: '请选择机型', trigger: 'blur' }],
        stationNumberValue: [{ required: true, message: '请选择工位号', trigger: 'blur' }]
      }
    }
  },
  computed: {
    ...mapGetters([
      'id',
      'token',
      'departmentName'
    ])
  },
  watch: {
    // stationNumberValue() {
    //   for (let i = 0; i < this.stationNumber.length; i++) {
    //     if (this.stationNumber[i].value === this.stationNumberValue) {
    //       console.log(this.stationNumber[i].label, 'this.stationNumber[i].label')
    //       this.stationName = this.stationNumber[i].labelName
    //     }
    //   }
    //   if (!this.stationNumberValue) {
    //     this.stationName = ''
    //   }
    // },
    engineTypeValue1() {
      console.log(1234)
      for (let i = 0; i < this.engineType.length; i++) {
        if (this.engineType[i].value === this.engineTypeValue1) {
          this.engineTypeName = this.engineType[i].labelName
          console.log(this.engineTypeName, 'this.engineTypeName')
        }
      }
    }
  },
  created() {
    this.getStationNumber()
    this.getEndStation()
  },
  mounted() {
    this.searchTable()
    this.searchTable1()
  },
  methods: {
    getStationNumber() {
      this.stationNumber = []
      var param = []
      var Data = this.CreateData('11', 'MES_计划BOM_工位与名称_查询', param)
      this.ExecDatabase(Data).then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.stationNumber.push({
            label: `【${response.data[i].工位号}】${response.data[i].工位名称}`,
            value: response.data[i].工位号,
            labelName: response.data[i].工位名称
          })
        }
      })
    },
    // 初始化获取产品型号
    getEndStation() {
      this.engineType = []
      var param = []
      var Data = this.CreateData('11', 'CATL_基础信息_机型信息_查询', param)
      this.ExecDatabase(Data).then(response => {
        if (response.data.length > 0) this.engineTypeValue = response.data[0].机型ID
        for (let i = 0; i < response.data.length; i++) {
          this.engineType.push({
            label: response.data[i].机型号,
            value: response.data[i].机型ID,
            labelName: response.data[i].机型号
          })
        }
      })
    },
    // 表格颜色变化
    tableRowClassName({ row, rowIndex }) {
      // console.log(row, rowIndex)
      if (rowIndex % 2 === 0) {
        return 'black'
      } else {
        return 'red'
      }
    },
    // 查询MES消息
    searchTable() {
      this.tableData = []
      var param = []
      param[0] = ['工位号', this.stationNumberValue]
      var Data = this.CreateData('11', 'CATL_出厂报告_基础项目_查询', param)
      this.ExecDatabase(Data).then(response => {
        if (response.data.length !== 0) {
          this.tableData = response.data
        }
      })
    },
    searchTable1() {
      this.tableData1 = []
      var param = []
      var Data = this.CreateData('11', 'CATL_出厂报告_基础_查询', param)
      this.ExecDatabase(Data).then(response => {
        if (response.data.length !== 0) {
          this.tableData1 = response.data
          this.tableData1.push({
            数据名称: '',
            数据值: 'button'
          })
        }
      })
    },
    addTo() {
      this.title = '添加'
      this.dialogFormVisible = true
    },
    submitAdd(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          var param = []
          param[0] = ['工位号', this.form.stationNumber]
          param[1] = ['类别', this.form.类别]
          param[2] = ['测试方法', this.form.测试方法]
          param[3] = ['检测要求', this.form.检测要求]
          param[4] = ['实测值', this.form.实测值]
          var Data = this.CreateData('12', 'CATL_出厂报告_基础项目_增加', param)
          this.ExecDatabase(Data).then(response => {
            if (response.data[0].result === '1') {
              this.$message({
                message: '增加成功',
                type: 'success'
              })
              this.dialogFormVisible = false
              this.searchTable()
            } else {
              this.$message.error('增加失败！')
            }
          })
        } else {
          return false
        }
      })
    },
    callOff() {
      this.dialogFormVisible = false
      this.$refs['form'].resetFields()
      this.form.stationNumber = ''
      this.form.moduleDescription = ''
      this.form.number = ''
      this.form.text = ''
      this.engineTypeName = ''
      this.title = ''
    },
    callOff1() {
      this.dialogFormVisible1 = false
      this.$refs['form1'].resetFields()
      this.form.stationNumber = ''
      this.form.moduleDescription = ''
      this.form.number = ''
      this.form.text = ''
      this.engineTypeName = ''
      this.title = ''
    },
    editInformation(row) {
      this.form.ID = row.ID
      this.form.stationNumber = row.工位号
      this.form.类别 = row.类别
      this.form.测试方法 = row.测试方法
      this.form.检测要求 = row.检测要求
      this.form.实测值 = row.实测值
      this.title = '编辑'
      this.dialogFormVisible = true
    },
    // 编辑消息
    submitUpdate(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          var param = []
          param[0] = ['类别', this.form.类别]
          param[1] = ['测试方法', this.form.测试方法]
          param[2] = ['检测要求', this.form.检测要求]
          param[3] = ['实测值', this.form.实测值]
          param[4] = ['ID', this.form.ID]
          var Data = this.CreateData('12', 'CATL_出厂报告_基础项目_编辑', param)
          this.ExecDatabase(Data).then(response => {
            if (response.data[0].result === '1') {
              this.$message({
                message: '修改成功',
                type: 'success'
              })
              this.dialogFormVisible = false
              this.searchTable()
            } else {
              this.$message.error('修改失败！')
            }
          })
        } else {
          return false
        }
      })
    },
    deleteInformation(row) {
      this.$confirm('此操作将永久删除该行, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        var param = []
        param[0] = ['ID', row.ID]
        var Data = this.CreateData('12', 'CATL_出厂报告_基础项目_删除', param)
        this.ExecDatabase(Data).then(response => {
          if (response.data[0].result === '1') {
            this.$message({
              message: '删除成功',
              type: 'success'
            })
            this.searchTable()
          } else {
            this.$message.error('删除失败！')
          }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消删除'
        })
      })
    },
    submitUpdate1() {
      const value1 = this.tableData1[0].数据值
      const value2 = this.tableData1[1].数据值
      const value3 = this.tableData1[2].数据值
      const value4 = this.tableData1[3].数据值
      var param = []
      param[0] = ['数据值1', value1]
      param[1] = ['数据值2', value2]
      param[2] = ['数据值3', value3]
      param[3] = ['数据值4', value4]
      var Data = this.CreateData('12', 'CATL_出厂报告_基础_编辑', param)
      this.ExecDatabase(Data).then(response => {
        if (response.data[0].result === '1') {
          this.$message({
            message: '修改成功',
            type: 'success'
          })
          this.searchTable1()
        } else {
          this.$message.error('修改失败！')
        }
      })
    }
  }
}
</script>

<style scoped>
.topCard {
  margin: 5px;
}

.topDiv {
  margin-bottom: 10px;
}

.el-select {
  width: 200px
}

.el-input {
  width: 200px
}

.text {
  font-size: 14px;
}

.item {
  padding: 18px 0;
}

.box-card {
  position: absolute;
  right: 6px;
  top: 80px;
  width: 300px;
}

.el-table .warning-row {
  background: oldlace;
}

.el-table .success-row {
  background: #f0f9eb;
}

::v-deep.el-input.is-disabled .el-input__inner {
  color: #606266 !important;
}

::v-deep textarea {
  height: 100px;
}
</style>

